from __future__ import annotations
import ngsolve as ngs
import ngsolve.comp
import ngsolve.fem
import ngsolve.krylovspace
__all__ = ['CrankNicolson', 'ImplicitEuler', 'Newmark', 'ngs']
class CrankNicolson:
    def Integrate(self, u_start: ngsolve.comp.GridFunction, end_time: float, start_time: typing.Union[float, NoneType] = None, newton_args: typing.Union[dict, NoneType] = None, callback: typing.Union[typing.Callable, NoneType] = None):
        ...
    def Step(self, u: ngsolve.comp.GridFunction, dt: typing.Union[float, NoneType] = None, newton_args: typing.Union[dict, NoneType] = None):
        ...
    def __init__(self, equation: ngsolve.comp.SumOfIntegrals, dt: typing.Union[float, ngsolve.fem.Parameter], time: ngsolve.fem.Parameter = ..., pc_cls: typing.Type = ngsolve.comp.MultiGridPreconditioner, pc_args: typing.Union[dict, NoneType] = None, lin_solver_cls: typing.Type = ngsolve.krylovspace.CGSolver, lin_solver_args: typing.Union[dict, NoneType] = None):
        ...
class ImplicitEuler:
    def Integrate(self, u_start: ngsolve.comp.GridFunction, end_time: float, start_time: typing.Union[float, NoneType] = None, newton_args: typing.Union[dict, NoneType] = None, callback: typing.Union[typing.Callable, NoneType] = None):
        ...
    def Step(self, u: ngsolve.comp.GridFunction, dt: typing.Union[float, NoneType] = None, newton_args: typing.Union[dict, NoneType] = None):
        ...
    def __init__(self, equation: ngsolve.comp.SumOfIntegrals, dt: typing.Union[float, ngsolve.fem.Parameter], time: ngsolve.fem.Parameter = ..., pc_cls: typing.Type = ngsolve.comp.MultiGridPreconditioner, pc_args: typing.Union[dict, NoneType] = None, lin_solver_cls: typing.Type = ngsolve.krylovspace.CGSolver, lin_solver_args: typing.Union[dict, NoneType] = None):
        ...
class Newmark:
    def Integrate(self, u: ngsolve.comp.GridFunction, end_time: float, v: typing.Union[ngsolve.comp.GridFunction, NoneType] = None, a: typing.Union[ngsolve.comp.GridFunction, NoneType] = None, start_time: typing.Union[float, NoneType] = None, newton_args: typing.Union[dict, NoneType] = None, callback: typing.Union[typing.Callable, NoneType] = None):
        ...
    def Step(self, u: ngsolve.comp.GridFunction, v: ngsolve.comp.GridFunction, a: ngsolve.comp.GridFunction, dt: typing.Union[float, NoneType] = None, newton_args: typing.Union[dict, NoneType] = None):
        ...
    def __init__(self, equation: ngsolve.comp.SumOfIntegrals, dt: typing.Union[float, ngsolve.fem.Parameter], time: ngsolve.fem.Parameter = ..., pc_cls: typing.Type = ngsolve.comp.MultiGridPreconditioner, pc_args: typing.Union[dict, NoneType] = None, lin_solver_cls: typing.Type = ngsolve.krylovspace.CGSolver, lin_solver_args: typing.Union[dict, NoneType] = None):
        ...
